diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/model/address.cc ns-3.47/src/network/model/address.cc
--- ns-3.46/src/network/model/address.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/model/address.cc	2026-02-16 16:08:49.799230600 -0800
@@ -4,6 +4,7 @@
  * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ * Modified by: Dhiraj Lokesh <dhirajlokesh@gmail.com>
  */
 
 #include "address.h"
@@ -20,47 +21,41 @@
 
 NS_LOG_COMPONENT_DEFINE("Address");
 
-Address::Address()
-    : m_type(0),
-      m_len(0)
-{
-    // Buffer left uninitialized
-    NS_LOG_FUNCTION(this);
-}
+Address::KindTypeRegistry Address::m_typeRegistry;
 
 Address::Address(uint8_t type, const uint8_t* buffer, uint8_t len)
     : m_type(type),
       m_len(len)
 {
     NS_LOG_FUNCTION(this << static_cast<uint32_t>(type) << &buffer << static_cast<uint32_t>(len));
-    NS_ASSERT(m_len <= MAX_SIZE);
-    std::memcpy(m_data, buffer, m_len);
+    NS_ASSERT_MSG(m_len <= MAX_SIZE, "Address length too large");
+    NS_ASSERT_MSG(type != UNASSIGNED_TYPE, "Type 0 is reserved for uninitialized addresses.");
+    std::copy(buffer, buffer + len, m_data.begin());
 }
 
-Address::Address(const Address& address)
-    : m_type(address.m_type),
-      m_len(address.m_len)
+void
+Address::SetType(const std::string& kind, uint8_t length)
 {
-    NS_ASSERT(m_len <= MAX_SIZE);
-    std::memcpy(m_data, address.m_data, m_len);
-}
+    NS_LOG_FUNCTION(this << kind << static_cast<uint32_t>(length));
+    auto search = m_typeRegistry.find({kind, length});
+    NS_ASSERT_MSG(search != m_typeRegistry.end(),
+                  "No address with the given kind and length is registered.");
 
-Address&
-Address::operator=(const Address& address)
-{
-    NS_ASSERT(m_len <= MAX_SIZE);
-    m_type = address.m_type;
-    m_len = address.m_len;
-    NS_ASSERT(m_len <= MAX_SIZE);
-    std::memcpy(m_data, address.m_data, m_len);
-    return *this;
+    if (m_type != search->second)
+    {
+        NS_ASSERT_MSG(m_type == UNASSIGNED_TYPE,
+                      "You can only change the type of a type-0 address."
+                          << static_cast<uint32_t>(m_type));
+
+        m_type = search->second;
+    }
 }
 
 bool
 Address::IsInvalid() const
 {
     NS_LOG_FUNCTION(this);
-    return m_len == 0 && m_type == 0;
+    return m_len == 0 && m_type == UNASSIGNED_TYPE;
 }
 
 uint8_t
@@ -76,7 +71,7 @@
 {
     NS_LOG_FUNCTION(this << &buffer);
     NS_ASSERT(m_len <= MAX_SIZE);
-    std::memcpy(buffer, m_data, m_len);
+    std::copy(m_data.begin(), m_data.begin() + m_len, buffer);
     return m_len;
 }
 
@@ -87,7 +82,7 @@
     NS_ASSERT(len - m_len > 1);
     buffer[0] = m_type;
     buffer[1] = m_len;
-    std::memcpy(buffer + 2, m_data, m_len);
+    std::copy(m_data.begin(), m_data.begin() + m_len, buffer + 2);
     return m_len + 2;
 }
 
@@ -95,8 +90,10 @@
 Address::CopyFrom(const uint8_t* buffer, uint8_t len)
 {
     NS_LOG_FUNCTION(this << &buffer << static_cast<uint32_t>(len));
-    NS_ASSERT(len <= MAX_SIZE);
-    std::memcpy(m_data, buffer, len);
+    NS_ASSERT_MSG(m_len <= MAX_SIZE, "Address length too large");
+    NS_ASSERT_MSG(m_type != UNASSIGNED_TYPE,
+                  "Type-0 addresses are reserved. Please use SetType before using CopyFrom.");
+    std::copy(buffer, buffer + len, m_data.begin());
     m_len = len;
     return m_len;
 }
@@ -110,7 +107,7 @@
     m_len = buffer[1];
 
     NS_ASSERT(len - m_len > 1);
-    std::memcpy(m_data, buffer + 2, m_len);
+    std::copy(buffer + 2, buffer + 2 + m_len, m_data.begin());
     return m_len + 2;
 }
 
@@ -119,9 +116,7 @@
 {
     NS_LOG_FUNCTION(this << static_cast<uint32_t>(type) << static_cast<uint32_t>(len));
     NS_ASSERT(len <= MAX_SIZE);
-    /// @internal
-    /// Mac address type/length detection is discussed in \bugid{1568}
-    return (m_len == len && m_type == type) || (m_len >= len && m_type == 0);
+    return (m_len == len && m_type == type);
 }
 
 bool
@@ -132,12 +127,15 @@
 }
 
 uint8_t
-Address::Register()
+Address::Register(const std::string& kind, uint8_t length)
 {
-    NS_LOG_FUNCTION_NOARGS();
-    static uint8_t type = 1;
-    type++;
-    return type;
+    NS_LOG_FUNCTION(kind << length);
+    static uint8_t lastRegisteredType = UNASSIGNED_TYPE;
+    NS_ASSERT_MSG(m_typeRegistry.find({kind, length}) == m_typeRegistry.end(),
+                  "An address of the same kind and length is already registered.");
+    lastRegisteredType++;
+    m_typeRegistry[{kind, length}] = lastRegisteredType;
+    return lastRegisteredType;
 }
 
 uint32_t
@@ -153,7 +151,7 @@
     NS_LOG_FUNCTION(this << &buffer);
     buffer.WriteU8(m_type);
     buffer.WriteU8(m_len);
-    buffer.Write(m_data, m_len);
+    buffer.Write(m_data.data(), m_len);
 }
 
 void
@@ -163,83 +161,22 @@
     m_type = buffer.ReadU8();
     m_len = buffer.ReadU8();
     NS_ASSERT(m_len <= MAX_SIZE);
-    buffer.Read(m_data, m_len);
+    buffer.Read(m_data.data(), m_len);
 }
 
 ATTRIBUTE_HELPER_CPP(Address);
 
-bool
-operator==(const Address& a, const Address& b)
-{
-    /* Two addresses can be equal even if their types are
-     * different if one of the two types is zero. a type of
-     * zero identifies an Address which might contain meaningful
-     * payload but for which the type field could not be set because
-     * we did not know it. This can typically happen in the ARP
-     * layer where we receive an address from an ArpHeader but
-     * we do not know its type: we really want to be able to
-     * compare addresses without knowing their real type.
-     */
-    if (a.m_type != b.m_type && a.m_type != 0 && b.m_type != 0)
-    {
-        return false;
-    }
-    if (a.m_len != b.m_len)
-    {
-        return false;
-    }
-    return std::memcmp(a.m_data, b.m_data, a.m_len) == 0;
-}
-
-bool
-operator!=(const Address& a, const Address& b)
-{
-    return !(a == b);
-}
-
-bool
-operator<(const Address& a, const Address& b)
-{
-    if (a.m_type < b.m_type)
-    {
-        return true;
-    }
-    else if (a.m_type > b.m_type)
-    {
-        return false;
-    }
-    if (a.m_len < b.m_len)
-    {
-        return true;
-    }
-    else if (a.m_len > b.m_len)
-    {
-        return false;
-    }
-    NS_ASSERT(a.GetLength() == b.GetLength());
-    for (uint8_t i = 0; i < a.GetLength(); i++)
-    {
-        if (a.m_data[i] < b.m_data[i])
-        {
-            return true;
-        }
-        else if (a.m_data[i] > b.m_data[i])
-        {
-            return false;
-        }
-    }
-    return false;
-}
-
 std::ostream&
 operator<<(std::ostream& os, const Address& address)
 {
-    if (address.m_len == 0)
+    if (address.m_type == 0)
     {
+        os << "00-00:00";
         return os;
     }
+    std::ios_base::fmtflags ff = os.flags();
+    auto fill = os.fill('0');
     os.setf(std::ios::hex, std::ios::basefield);
-    os.fill('0');
     os << std::setw(2) << (uint32_t)address.m_type << "-" << std::setw(2) << (uint32_t)address.m_len
        << "-";
     for (uint8_t i = 0; i < (address.m_len - 1); ++i)
@@ -248,8 +185,8 @@
     }
     // Final byte not suffixed by ":"
     os << std::setw(2) << (uint32_t)address.m_data[address.m_len - 1];
-    os.setf(std::ios::dec, std::ios::basefield);
-    os.fill(' ');
+    os.flags(ff); // Restore stream flags
+    os.fill(fill);
     return os;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/model/address.h ns-3.47/src/network/model/address.h
--- ns-3.46/src/network/model/address.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/model/address.h	2026-02-16 16:08:49.799230600 -0800
@@ -4,6 +4,7 @@
  * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ * Modified by: Dhiraj Lokesh <dhirajlokesh@gmail.com>
  */
 
 #ifndef ADDRESS_H
@@ -14,8 +15,11 @@
 #include "ns3/attribute-helper.h"
 #include "ns3/attribute.h"
 
+#include <array>
+#include <compare>
 #include <ostream>
 #include <stdint.h>
+#include <unordered_map>
 
 namespace ns3
 {
@@ -26,6 +30,7 @@
  *
  * Network Address abstractions, including MAC, IPv4 and IPv6.
  */
+
 /**
  * @ingroup address
  * @brief a polymophic address class
@@ -62,6 +67,7 @@
  * {
  *   return Address (GetType (), m_buffer, 2);
  * }
+ *
  * MyAddress MyAddress::ConvertFrom (const Address &address)
  * {
  *   MyAddress ad;
@@ -69,9 +75,10 @@
  *   address.CopyTo (ad.m_buffer, 2);
  *   return ad;
  * }
+ *
  * uint8_t MyAddress::GetType ()
  * {
- *   static uint8_t type = Address::Register ();
+ *   static uint8_t type = Address::Register ("AddressType", 2);
  *   return type;
  * }
  * @endcode
@@ -84,10 +91,64 @@
  * operator Address() const;
  * @endcode
  *
+ * Furthermore, the specific address must call the static function
+ * ``Address::Register(kind, length)``. This is typically done in a static function like
+ * ``GetType``.
+ *
+ * The kind/length pair is used to set the address type when this is not known a-priori.
+ * The typical use-case is when you decode a header where the address kind is known, but its
+ * length is specified in the header itself. The concrete example is the ARP or NDP headers,
+ * where you have a MAC address with a variable length.
+ * In these cases the code will be (assuming the address is a MAC address):
+ * @code
+ * Address addr;
+ * addr.SetType("MacAddress", addressLen);
+ * ReadFrom(i, addr, addressLen);
+ * @endcode
+ *
+ * It is forbidden to have two specific addresses sharing the same kind and length.
+ *
  * @see attribute_Address
  */
 class Address
 {
+  private:
+    /**
+     * Key for the address registry: kind (string) / type (uint8_t)
+     */
+    using KindType = std::pair<std::string, uint8_t>;
+
+    /**
+     * Structure necessary to hash KindType, used as the key for the m_typeRegistry map
+     */
+    struct KeyHash
+    {
+        /**
+         * Functional operator for (string, uint8_t) hash computation.
+         * @param k the key to hash
+         * @return The key hash
+         */
+        std::size_t operator()(const KindType& k) const
+        {
+            return std::hash<std::string>()(k.first) ^ (std::hash<uint8_t>()(k.second));
+        }
+    };
+
+    /**
+     * Type of the address registry.
+     */
+    using KindTypeRegistry = std::unordered_map<KindType, uint8_t, Address::KeyHash>;
+
+    /**
+     * Container of allocated address types.
+     *
+     * The data is ordered by KindType (a {kind, length} pair), and sores the address type.
+     */
+    static KindTypeRegistry m_typeRegistry;
+
+    /// Unassigned Address type is reserved. Defined for clarity.
+    static constexpr uint8_t UNASSIGNED_TYPE{0};
+
   public:
     /**
      * The maximum size of a byte buffer which
@@ -98,7 +159,7 @@
     /**
      * Create an invalid address
      */
-    Address();
+    Address() = default;
     /**
      * @brief Create an address from a type and a buffer.
      *
@@ -114,19 +175,17 @@
      */
     Address(uint8_t type, const uint8_t* buffer, uint8_t len);
     /**
-     * @brief Create an address from another address.
-     * @param address the address to copy
-     */
-    Address(const Address& address);
-    /**
-     * @brief Basic assignment operator.
-     * @param address the address to copy
-     * @returns the address
+     * Set the address type.
+     *
+     * Works only if the type is not yet set.
+     * @see Register()
+     *
+     * @param kind address kind
+     * @param length address length
      */
-    Address& operator=(const Address& address);
-
+    void SetType(const std::string& kind, uint8_t length);
     /**
-     * @returns true if this address is invalid, false otherwise.
+     * @return true if this address is invalid, false otherwise.
      *
      * An address is invalid if and only if it was created
      * through the default constructor and it was never
@@ -135,19 +194,19 @@
     bool IsInvalid() const;
     /**
      * @brief Get the length of the underlying address.
-     * @returns the length of the underlying address.
+     * @return the length of the underlying address.
      */
     uint8_t GetLength() const;
     /**
      * @brief Copy the address bytes into a buffer.
      * @param buffer buffer to copy the address bytes to.
-     * @returns the number of bytes copied.
+     * @return the number of bytes copied.
      */
     uint32_t CopyTo(uint8_t buffer[MAX_SIZE]) const;
     /**
      * @param buffer buffer to copy the whole address data structure to
      * @param len the size of the buffer
-     * @returns the number of bytes copied.
+     * @return the number of bytes copied.
      *
      * Copies the type to buffer[0], the length of the address internal buffer
      * to buffer[1] and copies the internal buffer starting at buffer[2].  len
@@ -160,7 +219,7 @@
      *        a serialized representation of the address in network
      *        byte order.
      * @param len length of buffer
-     * @returns the number of bytes copied.
+     * @return the number of bytes copied.
      *
      * Copy the address bytes from buffer into to the internal buffer of this
      * address instance.
@@ -170,7 +229,7 @@
      * @param buffer pointer to a buffer of bytes which contain
      *        a copy of all the members of this Address class.
      * @param len the length of the buffer
-     * @returns the number of bytes copied.
+     * @return the number of bytes copied.
      *
      * The inverse of CopyAllTo().
      *
@@ -181,13 +240,13 @@
      * @param type a type id as returned by Address::Register
      * @param len the length associated to this type id.
      *
-     * @returns true if the type of the address stored internally
+     * @return true if the type of the address stored internally
      * is compatible with the requested type, false otherwise.
      */
     bool CheckCompatible(uint8_t type, uint8_t len) const;
     /**
      * @param type a type id as returned by Address::Register
-     * @returns true if the type of the address stored internally
+     * @return true if the type of the address stored internally
      * is compatible with the requested type, false otherwise.
      *
      * This method checks that the types are _exactly_ equal.
@@ -198,14 +257,28 @@
     bool IsMatchingType(uint8_t type) const;
     /**
      * Allocate a new type id for a new type of address.
-     * @returns a new type id.
+     *
+     * Each address-like class that needs to be converted to/from an
+     * ``Address`` needs to register itself once. This is typically done
+     * in the ``GetType`` function.
+     *
+     * The address kind and length are typically used during the buffer
+     * deserialization, where the exact address type is unknown, and only its
+     * kind and length are known, e.g., if you parse an ARP reply.
+     *
+     * It is not allowed to have two different addresses with the same
+     * kind and length.
+     *
+     * @param kind address kind, such as "MacAddress"
+     * @param length address length
+     * @return a new type id.
      */
-    static uint8_t Register();
+    static uint8_t Register(const std::string& kind, uint8_t length);
     /**
      * Get the number of bytes needed to serialize the underlying Address
      * Typically, this is GetLength () + 2
      *
-     * @returns the number of bytes required for an Address in serialized form
+     * @return the number of bytes required for an Address in serialized form
      */
     uint32_t GetSerializedSize() const;
     /**
@@ -221,40 +294,21 @@
      */
     void Deserialize(TagBuffer buffer);
 
-  private:
     /**
-     * @brief Equal to operator.
+     * @brief Three-way comparison operator.
      *
-     * @param a the first operand
-     * @param b the first operand
-     * @returns true if the operands are equal
+     * @param other the other address to compare with
+     * @return comparison result
      */
-    friend bool operator==(const Address& a, const Address& b);
-
-    /**
-     * @brief Not equal to operator.
-     *
-     * @param a the first operand
-     * @param b the first operand
-     * @returns true if the operands are not equal
-     */
-    friend bool operator!=(const Address& a, const Address& b);
-
-    /**
-     * @brief Less than operator.
-     *
-     * @param a the first operand
-     * @param b the first operand
-     * @returns true if the operand a is less than operand b
-     */
-    friend bool operator<(const Address& a, const Address& b);
+    constexpr std::strong_ordering operator<=>(const Address& other) const = default;
 
+  private:
     /**
      * @brief Stream insertion operator.
      *
      * @param os the stream
      * @param address the address
-     * @returns a reference to the stream
+     * @return a reference to the stream
      */
     friend std::ostream& operator<<(std::ostream& os, const Address& address);
 
@@ -263,20 +317,17 @@
      *
      * @param is the stream
      * @param address the address
-     * @returns a reference to the stream
+     * @return a reference to the stream
      */
     friend std::istream& operator>>(std::istream& is, Address& address);
 
-    uint8_t m_type;           //!< Type of the address
-    uint8_t m_len;            //!< Length of the address
-    uint8_t m_data[MAX_SIZE]; //!< The address value
+    uint8_t m_type{UNASSIGNED_TYPE};        //!< Type of the address
+    uint8_t m_len{0};                       //!< Length of the address
+    std::array<uint8_t, MAX_SIZE> m_data{}; //!< The address value
 };
 
 ATTRIBUTE_HELPER_HEADER(Address);
 
-bool operator==(const Address& a, const Address& b);
-bool operator!=(const Address& a, const Address& b);
-bool operator<(const Address& a, const Address& b);
 std::ostream& operator<<(std::ostream& os, const Address& address);
 std::istream& operator>>(std::istream& is, Address& address);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/model/buffer.h ns-3.47/src/network/model/buffer.h
--- ns-3.46/src/network/model/buffer.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/model/buffer.h	2026-02-16 16:08:49.799230600 -0800
@@ -112,6 +112,8 @@
          * This method works only if the two iterators point
          * to the same underlying buffer. Debug builds ensure
          * this with an assert.
+         *
+         * @hidecaller
          */
         uint32_t GetDistanceFrom(const Iterator& o) const;
 
@@ -131,6 +133,8 @@
          *
          * Write the data in buffer and advance the iterator position
          * by one byte.
+         *
+         * @hidecaller
          */
         inline void WriteU8(uint8_t data);
         /**
@@ -139,6 +143,8 @@
          *
          * Write the data in buffer len times and advance the iterator position
          * by len byte.
+         *
+         * @hidecaller
          */
         inline void WriteU8(uint8_t data, uint32_t len);
         /**
@@ -201,6 +207,8 @@
          * Write the data in buffer and advance the iterator position
          * by two bytes. The data is written in network order and the
          * input data is expected to be in host order.
+         *
+         * @hidecaller
          */
         inline void WriteHtonU16(uint16_t data);
         /**
@@ -252,6 +260,8 @@
          *
          * Read data and advance the Iterator by the number of bytes
          * read.
+         *
+         * @hidecaller
          */
         inline uint8_t ReadU8();
         /**
@@ -284,6 +294,8 @@
          * Read data and advance the Iterator by the number of bytes
          * read.
          * The data is read in network format and returned in host format.
+         *
+         * @hidecaller
          */
         inline uint16_t ReadNtohU16();
         /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/model/header.h ns-3.47/src/network/model/header.h
--- ns-3.46/src/network/model/header.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/model/header.h	2026-02-16 16:08:49.800230700 -0800
@@ -28,6 +28,9 @@
  *
  * Sample code which shows how to create a new type of Header, and how to use it,
  * is shown in the sample file samples/main-packet-header.cc
+ *
+ * Inheritance graph was not generated because of its size.
+ * @hideinheritancegraph
  */
 class Header : public Chunk
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/model/socket.h ns-3.47/src/network/model/socket.h
--- ns-3.46/src/network/model/socket.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/model/socket.h	2026-02-16 16:08:49.801230700 -0800
@@ -142,6 +142,7 @@
      *
      * @param node The node on which to create the socket
      * @param tid The TypeId of a SocketFactory class to use
+     * @hidecaller
      */
     static Ptr<Socket> CreateSocket(Ptr<Node> node, TypeId tid);
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/test/address-test.cc ns-3.47/src/network/test/address-test.cc
--- ns-3.46/src/network/test/address-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/src/network/test/address-test.cc	2026-02-16 16:08:49.801230700 -0800
@@ -0,0 +1,91 @@
+/*
+ * Copyright (c) 2025 Universita' di Firenze, Italy
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+
+#include "ns3/address.h"
+#include "ns3/test.h"
+
+#include <map>
+#include <string>
+
+using namespace ns3;
+
+/**
+ * @ingroup network-test
+ * @ingroup tests
+ *
+ * @brief Address classes Test
+ */
+class AddressTest : public TestCase
+{
+  public:
+    void DoRun() override;
+    AddressTest();
+};
+
+AddressTest::AddressTest()
+    : TestCase("Address class implementation")
+{
+}
+
+void
+AddressTest::DoRun()
+{
+    Address addrA;
+    Address addrB;
+    Address addrC;
+
+    // tests comparison of non-initialized addresses
+    NS_TEST_EXPECT_MSG_EQ(addrA == addrB, true, "Non-initialized addresses must be equal");
+
+    uint8_t bufferA[10]{1, 8, 0, 0, 0, 0, 0, 0, 0, 1};
+    uint8_t bufferB[10]{1, 8, 0, 0, 0, 0, 0, 0, 0, 2};
+    uint8_t bufferC[10]{1, 8, 0, 0, 0, 0, 0, 0, 0, 3};
+
+    addrA.CopyAllFrom(bufferA, 10);
+    addrB.CopyAllFrom(bufferB, 10);
+    addrC.CopyAllFrom(bufferC, 10);
+
+    // tests comparison of initialized addresses
+    NS_TEST_EXPECT_MSG_EQ(addrA < addrB, true, "Initialized addresses must be different, A < B");
+    NS_TEST_EXPECT_MSG_EQ(addrA < addrC, true, "Initialized addresses must be different, A < C");
+    NS_TEST_EXPECT_MSG_EQ(addrB < addrC, true, "Initialized addresses must be different, B < C");
+
+    std::map<Address, int8_t> theMap;
+    theMap.insert({addrC, 2});
+    theMap.insert({addrB, 1});
+    theMap.insert({addrA, 0});
+
+    int8_t test = -1;
+    for (auto [k, v] : theMap)
+    {
+        NS_TEST_EXPECT_MSG_EQ(v == test + 1, true, "Address map sorting must be correct");
+        test = v;
+    }
+}
+
+/**
+ * @ingroup network-test
+ * @ingroup tests
+ *
+ * @brief Address TestSuite
+ */
+class AddressTestSuite : public TestSuite
+{
+  public:
+    AddressTestSuite();
+
+  private:
+};
+
+AddressTestSuite::AddressTestSuite()
+    : TestSuite("address", Type::UNIT)
+{
+    AddTestCase(new AddressTest(), TestCase::Duration::QUICK);
+}
+
+static AddressTestSuite g_addressTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/test/ipv6-address-test-suite.cc ns-3.47/src/network/test/ipv6-address-test-suite.cc
--- ns-3.46/src/network/test/ipv6-address-test-suite.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/test/ipv6-address-test-suite.cc	2026-02-16 16:08:49.802230600 -0800
@@ -35,7 +35,7 @@
 void
 Ipv6AddressTestCase::DoRun()
 {
-    Ipv6Address ip = Ipv6Address("2001:db8::1");
+    auto ip = Ipv6Address("2001:db8::1");
     uint8_t ipBytes[16];
     ip.Serialize(ipBytes);
     NS_TEST_ASSERT_MSG_EQ(ipBytes[0], 0x20, "Failed string conversion");
@@ -81,6 +81,11 @@
     NS_TEST_ASSERT_MSG_EQ(ipBytes[7], 0x01, "Failed string conversion");
     NS_TEST_ASSERT_MSG_EQ(ipBytes[15], 1, "Failed string conversion");
 
+    // This test checks that we're not comparing the optional member variable.
+    Ipv6Address addr = ip;
+    ip.GetHash();
+    NS_TEST_ASSERT_MSG_EQ(ip, addr, "Failed address comparison");
+
     // Please add more tests below
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/utils/data-rate.cc ns-3.47/src/network/utils/data-rate.cc
--- ns-3.46/src/network/utils/data-rate.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/utils/data-rate.cc	2026-02-16 16:08:49.803230800 -0800
@@ -180,42 +180,6 @@
     return *this;
 }
 
-bool
-DataRate::operator<(const DataRate& rhs) const
-{
-    return m_bps < rhs.m_bps;
-}
-
-bool
-DataRate::operator<=(const DataRate& rhs) const
-{
-    return m_bps <= rhs.m_bps;
-}
-
-bool
-DataRate::operator>(const DataRate& rhs) const
-{
-    return m_bps > rhs.m_bps;
-}
-
-bool
-DataRate::operator>=(const DataRate& rhs) const
-{
-    return m_bps >= rhs.m_bps;
-}
-
-bool
-DataRate::operator==(const DataRate& rhs) const
-{
-    return m_bps == rhs.m_bps;
-}
-
-bool
-DataRate::operator!=(const DataRate& rhs) const
-{
-    return m_bps != rhs.m_bps;
-}
-
 Time
 DataRate::CalculateBytesTxTime(uint32_t bytes) const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/utils/inet6-socket-address.cc ns-3.47/src/network/utils/inet6-socket-address.cc
--- ns-3.46/src/network/utils/inet6-socket-address.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/utils/inet6-socket-address.cc	2026-02-16 16:08:49.803230800 -0800
@@ -119,7 +119,7 @@
 Inet6SocketAddress::GetType()
 {
     NS_LOG_FUNCTION_NOARGS();
-    static uint8_t type = Address::Register();
+    static uint8_t type = Address::Register("IpAddress", 18);
     return type;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/utils/inet-socket-address.cc ns-3.47/src/network/utils/inet-socket-address.cc
--- ns-3.46/src/network/utils/inet-socket-address.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/utils/inet-socket-address.cc	2026-02-16 16:08:49.803230800 -0800
@@ -120,7 +120,7 @@
 InetSocketAddress::GetType()
 {
     NS_LOG_FUNCTION_NOARGS();
-    static uint8_t type = Address::Register();
+    static uint8_t type = Address::Register("IpAddress", 6);
     return type;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/utils/inet-socket-address.h ns-3.47/src/network/utils/inet-socket-address.h
--- ns-3.46/src/network/utils/inet-socket-address.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/utils/inet-socket-address.h	2026-02-16 16:08:49.803230800 -0800
@@ -94,6 +94,7 @@
      *
      * @param address the Address instance to convert from.
      * @returns an InetSocketAddress
+     * @hidecaller
      */
     static InetSocketAddress ConvertFrom(const Address& address);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/utils/ipv4-address.cc ns-3.47/src/network/utils/ipv4-address.cc
--- ns-3.46/src/network/utils/ipv4-address.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/utils/ipv4-address.cc	2026-02-16 16:08:49.803230800 -0800
@@ -25,12 +25,6 @@
 
 NS_LOG_COMPONENT_DEFINE("Ipv4Address");
 
-Ipv4Mask::Ipv4Mask()
-    : m_mask(0x66666666)
-{
-    NS_LOG_FUNCTION(this);
-}
-
 Ipv4Mask::Ipv4Mask(uint32_t mask)
     : m_mask(mask)
 {
@@ -137,24 +131,10 @@
     return tmp;
 }
 
-/**
- *  Value of a not-yet-initialized IPv4 address, corresponding to 102.102.102.102.
- *  This is totally arbitrary.
- */
-static constexpr uint32_t UNINITIALIZED = 0x66666666U;
-
-Ipv4Address::Ipv4Address()
-    : m_address(UNINITIALIZED),
-      m_initialized(false)
-{
-    NS_LOG_FUNCTION(this);
-}
-
 Ipv4Address::Ipv4Address(uint32_t address)
 {
     NS_LOG_FUNCTION(this << address);
     m_address = address;
-    m_initialized = true;
 }
 
 Ipv4Address::Ipv4Address(const char* address)
@@ -163,15 +143,27 @@
 
     if (inet_pton(AF_INET, address, &m_address) <= 0)
     {
-        NS_LOG_LOGIC("Error, can not build an IPv4 address from an invalid string: " << address);
-        m_address = 0;
-        m_initialized = false;
+        NS_ABORT_MSG("Error, can not build an IPv4 address from an invalid string: " << address);
         return;
     }
-    m_initialized = true;
     m_address = ntohl(m_address);
 }
 
+bool
+Ipv4Address::CheckCompatible(const std::string& addressStr)
+{
+    NS_LOG_FUNCTION(addressStr);
+
+    uint32_t buffer;
+
+    if (inet_pton(AF_INET, addressStr.c_str(), &buffer) <= 0)
+    {
+        NS_LOG_WARN("Error, can not build an IPv4 address from an invalid string: " << addressStr);
+        return false;
+    }
+    return true;
+}
+
 uint32_t
 Ipv4Address::Get() const
 {
@@ -184,7 +176,6 @@
 {
     NS_LOG_FUNCTION(this << address);
     m_address = address;
-    m_initialized = true;
 }
 
 void
@@ -193,12 +184,9 @@
     NS_LOG_FUNCTION(this << address);
     if (inet_pton(AF_INET, address, &m_address) <= 0)
     {
-        NS_LOG_LOGIC("Error, can not build an IPv4 address from an invalid string: " << address);
-        m_address = 0;
-        m_initialized = false;
+        NS_ABORT_MSG("Error, can not build an IPv4 address from an invalid string: " << address);
         return;
     }
-    m_initialized = true;
     m_address = ntohl(m_address);
 }
 
@@ -238,7 +226,7 @@
 Ipv4Address::IsInitialized() const
 {
     NS_LOG_FUNCTION(this);
-    return m_initialized;
+    return true;
 }
 
 bool
@@ -312,7 +300,6 @@
     ipv4.m_address |= buf[2];
     ipv4.m_address <<= 8;
     ipv4.m_address |= buf[3];
-    ipv4.m_initialized = true;
 
     return ipv4;
 }
@@ -361,7 +348,7 @@
 Ipv4Address::GetType()
 {
     NS_LOG_FUNCTION_NOARGS();
-    static uint8_t type = Address::Register();
+    static uint8_t type = Address::Register("IpAddress", 4);
     return type;
 }
 
